<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCrossRegionalAssociation ArrayType
 * @subpackage Arrays
 */
class ArrayOfCrossRegionalAssociation extends AbstractStructArrayBase
{
    /**
     * The CrossRegionalAssociation
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CrossRegionalAssociation[]
     */
    public $CrossRegionalAssociation;
    /**
     * Constructor method for ArrayOfCrossRegionalAssociation
     * @uses ArrayOfCrossRegionalAssociation::setCrossRegionalAssociation()
     * @param \StructType\CrossRegionalAssociation[] $crossRegionalAssociation
     */
    public function __construct(array $crossRegionalAssociation = array())
    {
        $this
            ->setCrossRegionalAssociation($crossRegionalAssociation);
    }
    /**
     * Get CrossRegionalAssociation value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CrossRegionalAssociation[]|null
     */
    public function getCrossRegionalAssociation()
    {
        return isset($this->CrossRegionalAssociation) ? $this->CrossRegionalAssociation : null;
    }
    /**
     * Set CrossRegionalAssociation value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CrossRegionalAssociation[] $crossRegionalAssociation
     * @return \ArrayType\ArrayOfCrossRegionalAssociation
     */
    public function setCrossRegionalAssociation(array $crossRegionalAssociation = array())
    {
        foreach ($crossRegionalAssociation as $arrayOfCrossRegionalAssociationCrossRegionalAssociationItem) {
            // validation for constraint: itemType
            if (!$arrayOfCrossRegionalAssociationCrossRegionalAssociationItem instanceof \StructType\CrossRegionalAssociation) {
                throw new \InvalidArgumentException(sprintf('The CrossRegionalAssociation property can only contain items of \StructType\CrossRegionalAssociation, "%s" given', is_object($arrayOfCrossRegionalAssociationCrossRegionalAssociationItem) ? get_class($arrayOfCrossRegionalAssociationCrossRegionalAssociationItem) : gettype($arrayOfCrossRegionalAssociationCrossRegionalAssociationItem)), __LINE__);
            }
        }
        if (is_null($crossRegionalAssociation) || (is_array($crossRegionalAssociation) && empty($crossRegionalAssociation))) {
            unset($this->CrossRegionalAssociation);
        } else {
            $this->CrossRegionalAssociation = $crossRegionalAssociation;
        }
        return $this;
    }
    /**
     * Add item to CrossRegionalAssociation value
     * @throws \InvalidArgumentException
     * @param \StructType\CrossRegionalAssociation $item
     * @return \ArrayType\ArrayOfCrossRegionalAssociation
     */
    public function addToCrossRegionalAssociation(\StructType\CrossRegionalAssociation $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CrossRegionalAssociation) {
            throw new \InvalidArgumentException(sprintf('The CrossRegionalAssociation property can only contain items of \StructType\CrossRegionalAssociation, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CrossRegionalAssociation[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CrossRegionalAssociation|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CrossRegionalAssociation|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CrossRegionalAssociation|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CrossRegionalAssociation|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CrossRegionalAssociation|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CrossRegionalAssociation
     */
    public function getAttributeName()
    {
        return 'CrossRegionalAssociation';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCrossRegionalAssociation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
