<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfUpcomingAutopayEvent ArrayType
 * @subpackage Arrays
 */
class ArrayOfUpcomingAutopayEvent extends AbstractStructArrayBase
{
    /**
     * The UpcomingAutopayEvent
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UpcomingAutopayEvent[]
     */
    public $UpcomingAutopayEvent;
    /**
     * Constructor method for ArrayOfUpcomingAutopayEvent
     * @uses ArrayOfUpcomingAutopayEvent::setUpcomingAutopayEvent()
     * @param \StructType\UpcomingAutopayEvent[] $upcomingAutopayEvent
     */
    public function __construct(array $upcomingAutopayEvent = array())
    {
        $this
            ->setUpcomingAutopayEvent($upcomingAutopayEvent);
    }
    /**
     * Get UpcomingAutopayEvent value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UpcomingAutopayEvent[]|null
     */
    public function getUpcomingAutopayEvent()
    {
        return isset($this->UpcomingAutopayEvent) ? $this->UpcomingAutopayEvent : null;
    }
    /**
     * Set UpcomingAutopayEvent value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UpcomingAutopayEvent[] $upcomingAutopayEvent
     * @return \ArrayType\ArrayOfUpcomingAutopayEvent
     */
    public function setUpcomingAutopayEvent(array $upcomingAutopayEvent = array())
    {
        foreach ($upcomingAutopayEvent as $arrayOfUpcomingAutopayEventUpcomingAutopayEventItem) {
            // validation for constraint: itemType
            if (!$arrayOfUpcomingAutopayEventUpcomingAutopayEventItem instanceof \StructType\UpcomingAutopayEvent) {
                throw new \InvalidArgumentException(sprintf('The UpcomingAutopayEvent property can only contain items of \StructType\UpcomingAutopayEvent, "%s" given', is_object($arrayOfUpcomingAutopayEventUpcomingAutopayEventItem) ? get_class($arrayOfUpcomingAutopayEventUpcomingAutopayEventItem) : gettype($arrayOfUpcomingAutopayEventUpcomingAutopayEventItem)), __LINE__);
            }
        }
        if (is_null($upcomingAutopayEvent) || (is_array($upcomingAutopayEvent) && empty($upcomingAutopayEvent))) {
            unset($this->UpcomingAutopayEvent);
        } else {
            $this->UpcomingAutopayEvent = $upcomingAutopayEvent;
        }
        return $this;
    }
    /**
     * Add item to UpcomingAutopayEvent value
     * @throws \InvalidArgumentException
     * @param \StructType\UpcomingAutopayEvent $item
     * @return \ArrayType\ArrayOfUpcomingAutopayEvent
     */
    public function addToUpcomingAutopayEvent(\StructType\UpcomingAutopayEvent $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpcomingAutopayEvent) {
            throw new \InvalidArgumentException(sprintf('The UpcomingAutopayEvent property can only contain items of \StructType\UpcomingAutopayEvent, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->UpcomingAutopayEvent[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpcomingAutopayEvent|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpcomingAutopayEvent|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpcomingAutopayEvent|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpcomingAutopayEvent|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpcomingAutopayEvent|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpcomingAutopayEvent
     */
    public function getAttributeName()
    {
        return 'UpcomingAutopayEvent';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfUpcomingAutopayEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
