<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'AddArrival' => '\\StructType\\AddArrival',
            'AddArrivalRequest' => '\\StructType\\AddArrivalRequest',
            'MBRequest' => '\\StructType\\MBRequest',
            'SourceCredentials' => '\\StructType\\SourceCredentials',
            'ArrayOfInt' => '\\ArrayType\\ArrayOfInt',
            'UserCredentials' => '\\StructType\\UserCredentials',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'AddArrivalResponse' => '\\StructType\\AddArrivalResponse',
            'AddArrivalResult' => '\\StructType\\AddArrivalResult',
            'MBResult' => '\\StructType\\MBResult',
            'ClientService' => '\\StructType\\ClientService',
            'MBObject' => '\\StructType\\MBObject',
            'Site' => '\\StructType\\Site',
            'Program' => '\\StructType\\Program',
            'AddOrUpdateClients' => '\\StructType\\AddOrUpdateClients',
            'AddOrUpdateClientsRequest' => '\\StructType\\AddOrUpdateClientsRequest',
            'ArrayOfClient' => '\\ArrayType\\ArrayOfClient',
            'Client' => '\\StructType\\Client',
            'ArrayOfClientIndex' => '\\ArrayType\\ArrayOfClientIndex',
            'ClientIndex' => '\\StructType\\ClientIndex',
            'ArrayOfClientIndexValue' => '\\ArrayType\\ArrayOfClientIndexValue',
            'ClientIndexValue' => '\\StructType\\ClientIndexValue',
            'ClientCreditCard' => '\\StructType\\ClientCreditCard',
            'ArrayOfClientRelationship' => '\\ArrayType\\ArrayOfClientRelationship',
            'ClientRelationship' => '\\StructType\\ClientRelationship',
            'Relationship' => '\\StructType\\Relationship',
            'ArrayOfRep' => '\\ArrayType\\ArrayOfRep',
            'Rep' => '\\StructType\\Rep',
            'Staff' => '\\StructType\\Staff',
            'ArrayOfAppointment' => '\\ArrayType\\ArrayOfAppointment',
            'Appointment' => '\\StructType\\Appointment',
            'ScheduleItem' => '\\StructType\\ScheduleItem',
            'Unavailability' => '\\StructType\\Unavailability',
            'Availability' => '\\StructType\\Availability',
            'SessionType' => '\\StructType\\SessionType',
            'ArrayOfProgram' => '\\ArrayType\\ArrayOfProgram',
            'Location' => '\\StructType\\Location',
            'ArrayOfResource' => '\\ArrayType\\ArrayOfResource',
            'Resource' => '\\StructType\\Resource',
            'ArrayOfUnavailability' => '\\ArrayType\\ArrayOfUnavailability',
            'ArrayOfAvailability' => '\\ArrayType\\ArrayOfAvailability',
            'ArrayOfLocation' => '\\ArrayType\\ArrayOfLocation',
            'ArrayOfProviderIDUpdate' => '\\ArrayType\\ArrayOfProviderIDUpdate',
            'ProviderIDUpdate' => '\\StructType\\ProviderIDUpdate',
            'ArrayOfSalesRep' => '\\ArrayType\\ArrayOfSalesRep',
            'SalesRep' => '\\StructType\\SalesRep',
            'ArrayOfCustomClientField' => '\\ArrayType\\ArrayOfCustomClientField',
            'CustomClientField' => '\\StructType\\CustomClientField',
            'Liability' => '\\StructType\\Liability',
            'ProspectStage' => '\\StructType\\ProspectStage',
            'AddOrUpdateClientsResponse' => '\\StructType\\AddOrUpdateClientsResponse',
            'AddOrUpdateClientsResult' => '\\StructType\\AddOrUpdateClientsResult',
            'UpdateClientCrossRegional' => '\\StructType\\UpdateClientCrossRegional',
            'UpdateClientCrossRegionalRequest' => '\\StructType\\UpdateClientCrossRegionalRequest',
            'UpdateClientCrossRegionalResponse' => '\\StructType\\UpdateClientCrossRegionalResponse',
            'UpdateClientCrossRegionalResult' => '\\StructType\\UpdateClientCrossRegionalResult',
            'GetClients' => '\\StructType\\GetClients',
            'GetClientsRequest' => '\\StructType\\GetClientsRequest',
            'GetClientsResponse' => '\\StructType\\GetClientsResponse',
            'GetClientsResult' => '\\StructType\\GetClientsResult',
            'GetCrossRegionalClientAssociations' => '\\StructType\\GetCrossRegionalClientAssociations',
            'GetCrossRegionalClientAssociationsRequest' => '\\StructType\\GetCrossRegionalClientAssociationsRequest',
            'GetCrossRegionalClientAssociationsResponse' => '\\StructType\\GetCrossRegionalClientAssociationsResponse',
            'GetCrossRegionalClientAssociationsResult' => '\\StructType\\GetCrossRegionalClientAssociationsResult',
            'ArrayOfCrossRegionalAssociation' => '\\ArrayType\\ArrayOfCrossRegionalAssociation',
            'CrossRegionalAssociation' => '\\StructType\\CrossRegionalAssociation',
            'GetCustomClientFields' => '\\StructType\\GetCustomClientFields',
            'GetCustomClientFieldsRequest' => '\\StructType\\GetCustomClientFieldsRequest',
            'GetCustomClientFieldsResponse' => '\\StructType\\GetCustomClientFieldsResponse',
            'GetCustomClientFieldsResult' => '\\StructType\\GetCustomClientFieldsResult',
            'GetClientIndexes' => '\\StructType\\GetClientIndexes',
            'GetClientIndexesRequest' => '\\StructType\\GetClientIndexesRequest',
            'GetClientIndexesResponse' => '\\StructType\\GetClientIndexesResponse',
            'GetClientIndexesResult' => '\\StructType\\GetClientIndexesResult',
            'GetClientContactLogs' => '\\StructType\\GetClientContactLogs',
            'GetClientContactLogsRequest' => '\\StructType\\GetClientContactLogsRequest',
            'ArrayOfLong' => '\\ArrayType\\ArrayOfLong',
            'GetClientContactLogsResponse' => '\\StructType\\GetClientContactLogsResponse',
            'GetClientContactLogsResult' => '\\StructType\\GetClientContactLogsResult',
            'ArrayOfContactLog' => '\\ArrayType\\ArrayOfContactLog',
            'ContactLog' => '\\StructType\\ContactLog',
            'ArrayOfContactLogComment' => '\\ArrayType\\ArrayOfContactLogComment',
            'ContactLogComment' => '\\StructType\\ContactLogComment',
            'ArrayOfContactLogType' => '\\ArrayType\\ArrayOfContactLogType',
            'ContactLogType' => '\\StructType\\ContactLogType',
            'ArrayOfContactLogSubtype' => '\\ArrayType\\ArrayOfContactLogSubtype',
            'ContactLogSubtype' => '\\StructType\\ContactLogSubtype',
            'AddOrUpdateContactLogs' => '\\StructType\\AddOrUpdateContactLogs',
            'AddOrUpdateContactLogsRequest' => '\\StructType\\AddOrUpdateContactLogsRequest',
            'AddOrUpdateContactLogsResponse' => '\\StructType\\AddOrUpdateContactLogsResponse',
            'AddOrUpdateContactLogsResult' => '\\StructType\\AddOrUpdateContactLogsResult',
            'GetContactLogTypes' => '\\StructType\\GetContactLogTypes',
            'GetContactLogTypesRequest' => '\\StructType\\GetContactLogTypesRequest',
            'GetContactLogTypesResponse' => '\\StructType\\GetContactLogTypesResponse',
            'GetContactLogTypesResult' => '\\StructType\\GetContactLogTypesResult',
            'UploadClientDocument' => '\\StructType\\UploadClientDocument',
            'UploadClientDocumentRequest' => '\\StructType\\UploadClientDocumentRequest',
            'UploadClientDocumentResponse' => '\\StructType\\UploadClientDocumentResponse',
            'UploadClientDocumentResult' => '\\StructType\\UploadClientDocumentResult',
            'UploadClientPhoto' => '\\StructType\\UploadClientPhoto',
            'UploadClientPhotoRequest' => '\\StructType\\UploadClientPhotoRequest',
            'UploadClientPhotoResponse' => '\\StructType\\UploadClientPhotoResponse',
            'UploadClientPhotoResult' => '\\StructType\\UploadClientPhotoResult',
            'GetClientFormulaNotes' => '\\StructType\\GetClientFormulaNotes',
            'GetClientFormulaNotesRequest' => '\\StructType\\GetClientFormulaNotesRequest',
            'GetClientFormulaNotesResponse' => '\\StructType\\GetClientFormulaNotesResponse',
            'GetClientFormulaNotesResult' => '\\StructType\\GetClientFormulaNotesResult',
            'ArrayOfFormulaNote' => '\\ArrayType\\ArrayOfFormulaNote',
            'FormulaNote' => '\\StructType\\FormulaNote',
            'AddClientFormulaNote' => '\\StructType\\AddClientFormulaNote',
            'AddClientFormulaNoteRequest' => '\\StructType\\AddClientFormulaNoteRequest',
            'AddClientFormulaNoteResponse' => '\\StructType\\AddClientFormulaNoteResponse',
            'AddClientFormulaNoteResult' => '\\StructType\\AddClientFormulaNoteResult',
            'DeleteClientFormulaNote' => '\\StructType\\DeleteClientFormulaNote',
            'DeleteCientFormulaNoteRequest' => '\\StructType\\DeleteCientFormulaNoteRequest',
            'DeleteClientFormulaNoteResponse' => '\\StructType\\DeleteClientFormulaNoteResponse',
            'DeleteClientFormulaNoteResult' => '\\StructType\\DeleteClientFormulaNoteResult',
            'GetClientReferralTypes' => '\\StructType\\GetClientReferralTypes',
            'GetClientReferralTypesRequest' => '\\StructType\\GetClientReferralTypesRequest',
            'GetClientReferralTypesResponse' => '\\StructType\\GetClientReferralTypesResponse',
            'GetClientReferralTypesResult' => '\\StructType\\GetClientReferralTypesResult',
            'GetActiveClientMemberships' => '\\StructType\\GetActiveClientMemberships',
            'GetActiveClientMembershipsRequest' => '\\StructType\\GetActiveClientMembershipsRequest',
            'GetActiveClientMembershipsResponse' => '\\StructType\\GetActiveClientMembershipsResponse',
            'GetActiveClientMembershipsResult' => '\\StructType\\GetActiveClientMembershipsResult',
            'ArrayOfClientMembership' => '\\ArrayType\\ArrayOfClientMembership',
            'ClientMembership' => '\\StructType\\ClientMembership',
            'GetClientContracts' => '\\StructType\\GetClientContracts',
            'GetClientContractsRequest' => '\\StructType\\GetClientContractsRequest',
            'CrossRegionalRequest' => '\\StructType\\CrossRegionalRequest',
            'PagedBySitesMBRequest' => '\\StructType\\PagedBySitesMBRequest',
            'GetClientContractsResponse' => '\\StructType\\GetClientContractsResponse',
            'GetClientContractsResult' => '\\StructType\\GetClientContractsResult',
            'PagedBySitesMBResult' => '\\StructType\\PagedBySitesMBResult',
            'ArrayOfClientContract' => '\\ArrayType\\ArrayOfClientContract',
            'ClientContract' => '\\StructType\\ClientContract',
            'ArrayOfUpcomingAutopayEvent' => '\\ArrayType\\ArrayOfUpcomingAutopayEvent',
            'UpcomingAutopayEvent' => '\\StructType\\UpcomingAutopayEvent',
            'GetClientAccountBalances' => '\\StructType\\GetClientAccountBalances',
            'GetClientAccountBalancesRequest' => '\\StructType\\GetClientAccountBalancesRequest',
            'GetClientAccountBalancesResponse' => '\\StructType\\GetClientAccountBalancesResponse',
            'GetClientAccountBalancesResult' => '\\StructType\\GetClientAccountBalancesResult',
            'GetClientServices' => '\\StructType\\GetClientServices',
            'GetClientServicesRequest' => '\\StructType\\GetClientServicesRequest',
            'GetClientServicesResponse' => '\\StructType\\GetClientServicesResponse',
            'GetClientServicesResult' => '\\StructType\\GetClientServicesResult',
            'ArrayOfClientService' => '\\ArrayType\\ArrayOfClientService',
            'GetClientVisits' => '\\StructType\\GetClientVisits',
            'GetClientVisitsRequest' => '\\StructType\\GetClientVisitsRequest',
            'GetClientVisitsResponse' => '\\StructType\\GetClientVisitsResponse',
            'GetClientVisitsResult' => '\\StructType\\GetClientVisitsResult',
            'ArrayOfVisit' => '\\ArrayType\\ArrayOfVisit',
            'Visit' => '\\StructType\\Visit',
            'GetClientPurchases' => '\\StructType\\GetClientPurchases',
            'GetClientPurchasesRequest' => '\\StructType\\GetClientPurchasesRequest',
            'GetClientPurchasesResponse' => '\\StructType\\GetClientPurchasesResponse',
            'GetClientPurchasesResult' => '\\StructType\\GetClientPurchasesResult',
            'ArrayOfSaleItem' => '\\ArrayType\\ArrayOfSaleItem',
            'SaleItem' => '\\StructType\\SaleItem',
            'Sale' => '\\StructType\\Sale',
            'ArrayOfPurchasedItem' => '\\ArrayType\\ArrayOfPurchasedItem',
            'PurchasedItem' => '\\StructType\\PurchasedItem',
            'ArrayOfPayment' => '\\ArrayType\\ArrayOfPayment',
            'Payment' => '\\StructType\\Payment',
            'GetClientSchedule' => '\\StructType\\GetClientSchedule',
            'GetClientScheduleRequest' => '\\StructType\\GetClientScheduleRequest',
            'GetClientScheduleResponse' => '\\StructType\\GetClientScheduleResponse',
            'GetClientScheduleResult' => '\\StructType\\GetClientScheduleResult',
            'GetRequiredClientFields' => '\\StructType\\GetRequiredClientFields',
            'GetRequiredClientFieldsRequest' => '\\StructType\\GetRequiredClientFieldsRequest',
            'GetRequiredClientFieldsResponse' => '\\StructType\\GetRequiredClientFieldsResponse',
            'GetRequiredClientFieldsResult' => '\\StructType\\GetRequiredClientFieldsResult',
            'ValidateLogin' => '\\StructType\\ValidateLogin',
            'ValidateLoginRequest' => '\\StructType\\ValidateLoginRequest',
            'ValidateLoginResponse' => '\\StructType\\ValidateLoginResponse',
            'ValidateLoginResult' => '\\StructType\\ValidateLoginResult',
            'UpdateClientServices' => '\\StructType\\UpdateClientServices',
            'UpdateClientServicesRequest' => '\\StructType\\UpdateClientServicesRequest',
            'UpdateClientServicesResponse' => '\\StructType\\UpdateClientServicesResponse',
            'UpdateClientServicesResult' => '\\StructType\\UpdateClientServicesResult',
            'SendUserNewPassword' => '\\StructType\\SendUserNewPassword',
            'ClientSendUserNewPasswordRequest' => '\\StructType\\ClientSendUserNewPasswordRequest',
            'SendUserNewPasswordResponse' => '\\StructType\\SendUserNewPasswordResponse',
            'ClientSendUserNewPasswordResult' => '\\StructType\\ClientSendUserNewPasswordResult',
        );
    }
}
