<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddArrivalResult StructType
 * @subpackage Structs
 */
class AddArrivalResult extends MBResult
{
    /**
     * The ArrivalAdded
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ArrivalAdded;
    /**
     * The ClientService
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClientService
     */
    public $ClientService;
    /**
     * Constructor method for AddArrivalResult
     * @uses AddArrivalResult::setArrivalAdded()
     * @uses AddArrivalResult::setClientService()
     * @param bool $arrivalAdded
     * @param \StructType\ClientService $clientService
     */
    public function __construct($arrivalAdded = null, \StructType\ClientService $clientService = null)
    {
        $this
            ->setArrivalAdded($arrivalAdded)
            ->setClientService($clientService);
    }
    /**
     * Get ArrivalAdded value
     * @return bool
     */
    public function getArrivalAdded()
    {
        return $this->ArrivalAdded;
    }
    /**
     * Set ArrivalAdded value
     * @param bool $arrivalAdded
     * @return \StructType\AddArrivalResult
     */
    public function setArrivalAdded($arrivalAdded = null)
    {
        // validation for constraint: boolean
        if (!is_null($arrivalAdded) && !is_bool($arrivalAdded)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($arrivalAdded)), __LINE__);
        }
        $this->ArrivalAdded = $arrivalAdded;
        return $this;
    }
    /**
     * Get ClientService value
     * @return \StructType\ClientService|null
     */
    public function getClientService()
    {
        return $this->ClientService;
    }
    /**
     * Set ClientService value
     * @param \StructType\ClientService $clientService
     * @return \StructType\AddArrivalResult
     */
    public function setClientService(\StructType\ClientService $clientService = null)
    {
        $this->ClientService = $clientService;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddArrivalResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
