<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddOrUpdateClientsRequest StructType
 * @subpackage Structs
 */
class AddOrUpdateClientsRequest extends MBRequest
{
    /**
     * The Test
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $Test;
    /**
     * The SendEmail
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $SendEmail;
    /**
     * The UpdateAction
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UpdateAction;
    /**
     * The Clients
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfClient
     */
    public $Clients;
    /**
     * Constructor method for AddOrUpdateClientsRequest
     * @uses AddOrUpdateClientsRequest::setTest()
     * @uses AddOrUpdateClientsRequest::setSendEmail()
     * @uses AddOrUpdateClientsRequest::setUpdateAction()
     * @uses AddOrUpdateClientsRequest::setClients()
     * @param bool $test
     * @param bool $sendEmail
     * @param string $updateAction
     * @param \ArrayType\ArrayOfClient $clients
     */
    public function __construct($test = null, $sendEmail = null, $updateAction = null, \ArrayType\ArrayOfClient $clients = null)
    {
        $this
            ->setTest($test)
            ->setSendEmail($sendEmail)
            ->setUpdateAction($updateAction)
            ->setClients($clients);
    }
    /**
     * Get Test value
     * @return bool
     */
    public function getTest()
    {
        return $this->Test;
    }
    /**
     * Set Test value
     * @param bool $test
     * @return \StructType\AddOrUpdateClientsRequest
     */
    public function setTest($test = null)
    {
        // validation for constraint: boolean
        if (!is_null($test) && !is_bool($test)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($test)), __LINE__);
        }
        $this->Test = $test;
        return $this;
    }
    /**
     * Get SendEmail value
     * @return bool
     */
    public function getSendEmail()
    {
        return $this->SendEmail;
    }
    /**
     * Set SendEmail value
     * @param bool $sendEmail
     * @return \StructType\AddOrUpdateClientsRequest
     */
    public function setSendEmail($sendEmail = null)
    {
        // validation for constraint: boolean
        if (!is_null($sendEmail) && !is_bool($sendEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sendEmail)), __LINE__);
        }
        $this->SendEmail = $sendEmail;
        return $this;
    }
    /**
     * Get UpdateAction value
     * @return string|null
     */
    public function getUpdateAction()
    {
        return $this->UpdateAction;
    }
    /**
     * Set UpdateAction value
     * @param string $updateAction
     * @return \StructType\AddOrUpdateClientsRequest
     */
    public function setUpdateAction($updateAction = null)
    {
        // validation for constraint: string
        if (!is_null($updateAction) && !is_string($updateAction)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($updateAction)), __LINE__);
        }
        $this->UpdateAction = $updateAction;
        return $this;
    }
    /**
     * Get Clients value
     * @return \ArrayType\ArrayOfClient|null
     */
    public function getClients()
    {
        return $this->Clients;
    }
    /**
     * Set Clients value
     * @param \ArrayType\ArrayOfClient $clients
     * @return \StructType\AddOrUpdateClientsRequest
     */
    public function setClients(\ArrayType\ArrayOfClient $clients = null)
    {
        $this->Clients = $clients;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddOrUpdateClientsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
