<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AddOrUpdateContactLogsRequest StructType
 * @subpackage Structs
 */
class AddOrUpdateContactLogsRequest extends MBRequest
{
    /**
     * The Test
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $Test;
    /**
     * The UpdateAction
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $UpdateAction;
    /**
     * The ContactLogs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfContactLog
     */
    public $ContactLogs;
    /**
     * Constructor method for AddOrUpdateContactLogsRequest
     * @uses AddOrUpdateContactLogsRequest::setTest()
     * @uses AddOrUpdateContactLogsRequest::setUpdateAction()
     * @uses AddOrUpdateContactLogsRequest::setContactLogs()
     * @param bool $test
     * @param string $updateAction
     * @param \ArrayType\ArrayOfContactLog $contactLogs
     */
    public function __construct($test = null, $updateAction = null, \ArrayType\ArrayOfContactLog $contactLogs = null)
    {
        $this
            ->setTest($test)
            ->setUpdateAction($updateAction)
            ->setContactLogs($contactLogs);
    }
    /**
     * Get Test value
     * @return bool
     */
    public function getTest()
    {
        return $this->Test;
    }
    /**
     * Set Test value
     * @param bool $test
     * @return \StructType\AddOrUpdateContactLogsRequest
     */
    public function setTest($test = null)
    {
        // validation for constraint: boolean
        if (!is_null($test) && !is_bool($test)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($test)), __LINE__);
        }
        $this->Test = $test;
        return $this;
    }
    /**
     * Get UpdateAction value
     * @return string|null
     */
    public function getUpdateAction()
    {
        return $this->UpdateAction;
    }
    /**
     * Set UpdateAction value
     * @param string $updateAction
     * @return \StructType\AddOrUpdateContactLogsRequest
     */
    public function setUpdateAction($updateAction = null)
    {
        // validation for constraint: string
        if (!is_null($updateAction) && !is_string($updateAction)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($updateAction)), __LINE__);
        }
        $this->UpdateAction = $updateAction;
        return $this;
    }
    /**
     * Get ContactLogs value
     * @return \ArrayType\ArrayOfContactLog|null
     */
    public function getContactLogs()
    {
        return $this->ContactLogs;
    }
    /**
     * Set ContactLogs value
     * @param \ArrayType\ArrayOfContactLog $contactLogs
     * @return \StructType\AddOrUpdateContactLogsRequest
     */
    public function setContactLogs(\ArrayType\ArrayOfContactLog $contactLogs = null)
    {
        $this->ContactLogs = $contactLogs;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AddOrUpdateContactLogsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
