<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactLog StructType
 * @subpackage Structs
 */
class ContactLog extends MBObject
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var int
     */
    public $ID;
    /**
     * The CreatedBy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Staff
     */
    public $CreatedBy;
    /**
     * The Client
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Client
     */
    public $Client;
    /**
     * The CreatedDateTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CreatedDateTime;
    /**
     * The FollowupByDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $FollowupByDate;
    /**
     * The ContactName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ContactName;
    /**
     * The Text
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Text;
    /**
     * The AssignedTo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Staff
     */
    public $AssignedTo;
    /**
     * The ContactMethod
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ContactMethod;
    /**
     * The IsSystemGenerated
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $IsSystemGenerated;
    /**
     * The Comments
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfContactLogComment
     */
    public $Comments;
    /**
     * The Types
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfContactLogType
     */
    public $Types;
    /**
     * The Action
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Action;
    /**
     * Constructor method for ContactLog
     * @uses ContactLog::setID()
     * @uses ContactLog::setCreatedBy()
     * @uses ContactLog::setClient()
     * @uses ContactLog::setCreatedDateTime()
     * @uses ContactLog::setFollowupByDate()
     * @uses ContactLog::setContactName()
     * @uses ContactLog::setText()
     * @uses ContactLog::setAssignedTo()
     * @uses ContactLog::setContactMethod()
     * @uses ContactLog::setIsSystemGenerated()
     * @uses ContactLog::setComments()
     * @uses ContactLog::setTypes()
     * @uses ContactLog::setAction()
     * @param int $iD
     * @param \StructType\Staff $createdBy
     * @param \StructType\Client $client
     * @param string $createdDateTime
     * @param string $followupByDate
     * @param string $contactName
     * @param string $text
     * @param \StructType\Staff $assignedTo
     * @param string $contactMethod
     * @param bool $isSystemGenerated
     * @param \ArrayType\ArrayOfContactLogComment $comments
     * @param \ArrayType\ArrayOfContactLogType $types
     * @param string $action
     */
    public function __construct($iD = null, \StructType\Staff $createdBy = null, \StructType\Client $client = null, $createdDateTime = null, $followupByDate = null, $contactName = null, $text = null, \StructType\Staff $assignedTo = null, $contactMethod = null, $isSystemGenerated = null, \ArrayType\ArrayOfContactLogComment $comments = null, \ArrayType\ArrayOfContactLogType $types = null, $action = null)
    {
        $this
            ->setID($iD)
            ->setCreatedBy($createdBy)
            ->setClient($client)
            ->setCreatedDateTime($createdDateTime)
            ->setFollowupByDate($followupByDate)
            ->setContactName($contactName)
            ->setText($text)
            ->setAssignedTo($assignedTo)
            ->setContactMethod($contactMethod)
            ->setIsSystemGenerated($isSystemGenerated)
            ->setComments($comments)
            ->setTypes($types)
            ->setAction($action);
    }
    /**
     * Get ID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return int|null
     */
    public function getID()
    {
        return isset($this->ID) ? $this->ID : null;
    }
    /**
     * Set ID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param int $iD
     * @return \StructType\ContactLog
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        if (is_null($iD) || (is_array($iD) && empty($iD))) {
            unset($this->ID);
        } else {
            $this->ID = $iD;
        }
        return $this;
    }
    /**
     * Get CreatedBy value
     * @return \StructType\Staff|null
     */
    public function getCreatedBy()
    {
        return $this->CreatedBy;
    }
    /**
     * Set CreatedBy value
     * @param \StructType\Staff $createdBy
     * @return \StructType\ContactLog
     */
    public function setCreatedBy(\StructType\Staff $createdBy = null)
    {
        $this->CreatedBy = $createdBy;
        return $this;
    }
    /**
     * Get Client value
     * @return \StructType\Client|null
     */
    public function getClient()
    {
        return $this->Client;
    }
    /**
     * Set Client value
     * @param \StructType\Client $client
     * @return \StructType\ContactLog
     */
    public function setClient(\StructType\Client $client = null)
    {
        $this->Client = $client;
        return $this;
    }
    /**
     * Get CreatedDateTime value
     * @return string|null
     */
    public function getCreatedDateTime()
    {
        return $this->CreatedDateTime;
    }
    /**
     * Set CreatedDateTime value
     * @param string $createdDateTime
     * @return \StructType\ContactLog
     */
    public function setCreatedDateTime($createdDateTime = null)
    {
        // validation for constraint: string
        if (!is_null($createdDateTime) && !is_string($createdDateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createdDateTime)), __LINE__);
        }
        $this->CreatedDateTime = $createdDateTime;
        return $this;
    }
    /**
     * Get FollowupByDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getFollowupByDate()
    {
        return isset($this->FollowupByDate) ? $this->FollowupByDate : null;
    }
    /**
     * Set FollowupByDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $followupByDate
     * @return \StructType\ContactLog
     */
    public function setFollowupByDate($followupByDate = null)
    {
        // validation for constraint: string
        if (!is_null($followupByDate) && !is_string($followupByDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($followupByDate)), __LINE__);
        }
        if (is_null($followupByDate) || (is_array($followupByDate) && empty($followupByDate))) {
            unset($this->FollowupByDate);
        } else {
            $this->FollowupByDate = $followupByDate;
        }
        return $this;
    }
    /**
     * Get ContactName value
     * @return string|null
     */
    public function getContactName()
    {
        return $this->ContactName;
    }
    /**
     * Set ContactName value
     * @param string $contactName
     * @return \StructType\ContactLog
     */
    public function setContactName($contactName = null)
    {
        // validation for constraint: string
        if (!is_null($contactName) && !is_string($contactName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contactName)), __LINE__);
        }
        $this->ContactName = $contactName;
        return $this;
    }
    /**
     * Get Text value
     * @return string|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * Set Text value
     * @param string $text
     * @return \StructType\ContactLog
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($text)), __LINE__);
        }
        $this->Text = $text;
        return $this;
    }
    /**
     * Get AssignedTo value
     * @return \StructType\Staff|null
     */
    public function getAssignedTo()
    {
        return $this->AssignedTo;
    }
    /**
     * Set AssignedTo value
     * @param \StructType\Staff $assignedTo
     * @return \StructType\ContactLog
     */
    public function setAssignedTo(\StructType\Staff $assignedTo = null)
    {
        $this->AssignedTo = $assignedTo;
        return $this;
    }
    /**
     * Get ContactMethod value
     * @return string|null
     */
    public function getContactMethod()
    {
        return $this->ContactMethod;
    }
    /**
     * Set ContactMethod value
     * @param string $contactMethod
     * @return \StructType\ContactLog
     */
    public function setContactMethod($contactMethod = null)
    {
        // validation for constraint: string
        if (!is_null($contactMethod) && !is_string($contactMethod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($contactMethod)), __LINE__);
        }
        $this->ContactMethod = $contactMethod;
        return $this;
    }
    /**
     * Get IsSystemGenerated value
     * @return bool|null
     */
    public function getIsSystemGenerated()
    {
        return $this->IsSystemGenerated;
    }
    /**
     * Set IsSystemGenerated value
     * @param bool $isSystemGenerated
     * @return \StructType\ContactLog
     */
    public function setIsSystemGenerated($isSystemGenerated = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSystemGenerated) && !is_bool($isSystemGenerated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isSystemGenerated)), __LINE__);
        }
        $this->IsSystemGenerated = $isSystemGenerated;
        return $this;
    }
    /**
     * Get Comments value
     * @return \ArrayType\ArrayOfContactLogComment|null
     */
    public function getComments()
    {
        return $this->Comments;
    }
    /**
     * Set Comments value
     * @param \ArrayType\ArrayOfContactLogComment $comments
     * @return \StructType\ContactLog
     */
    public function setComments(\ArrayType\ArrayOfContactLogComment $comments = null)
    {
        $this->Comments = $comments;
        return $this;
    }
    /**
     * Get Types value
     * @return \ArrayType\ArrayOfContactLogType|null
     */
    public function getTypes()
    {
        return $this->Types;
    }
    /**
     * Set Types value
     * @param \ArrayType\ArrayOfContactLogType $types
     * @return \StructType\ContactLog
     */
    public function setTypes(\ArrayType\ArrayOfContactLogType $types = null)
    {
        $this->Types = $types;
        return $this;
    }
    /**
     * Get Action value
     * @return string|null
     */
    public function getAction()
    {
        return $this->Action;
    }
    /**
     * Set Action value
     * @uses \EnumType\ActionCode::valueIsValid()
     * @uses \EnumType\ActionCode::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $action
     * @return \StructType\ContactLog
     */
    public function setAction($action = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\ActionCode::valueIsValid($action)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $action, implode(', ', \EnumType\ActionCode::getValidValues())), __LINE__);
        }
        $this->Action = $action;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactLog
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
