<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactLogComment StructType
 * @subpackage Structs
 */
class ContactLogComment extends MBObject
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Text
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Text;
    /**
     * The CreatedBy
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Staff
     */
    public $CreatedBy;
    /**
     * The CreatedDateTime
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CreatedDateTime;
    /**
     * Constructor method for ContactLogComment
     * @uses ContactLogComment::setID()
     * @uses ContactLogComment::setText()
     * @uses ContactLogComment::setCreatedBy()
     * @uses ContactLogComment::setCreatedDateTime()
     * @param int $iD
     * @param string $text
     * @param \StructType\Staff $createdBy
     * @param string $createdDateTime
     */
    public function __construct($iD = null, $text = null, \StructType\Staff $createdBy = null, $createdDateTime = null)
    {
        $this
            ->setID($iD)
            ->setText($text)
            ->setCreatedBy($createdBy)
            ->setCreatedDateTime($createdDateTime);
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\ContactLogComment
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Text value
     * @return string|null
     */
    public function getText()
    {
        return $this->Text;
    }
    /**
     * Set Text value
     * @param string $text
     * @return \StructType\ContactLogComment
     */
    public function setText($text = null)
    {
        // validation for constraint: string
        if (!is_null($text) && !is_string($text)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($text)), __LINE__);
        }
        $this->Text = $text;
        return $this;
    }
    /**
     * Get CreatedBy value
     * @return \StructType\Staff|null
     */
    public function getCreatedBy()
    {
        return $this->CreatedBy;
    }
    /**
     * Set CreatedBy value
     * @param \StructType\Staff $createdBy
     * @return \StructType\ContactLogComment
     */
    public function setCreatedBy(\StructType\Staff $createdBy = null)
    {
        $this->CreatedBy = $createdBy;
        return $this;
    }
    /**
     * Get CreatedDateTime value
     * @return string|null
     */
    public function getCreatedDateTime()
    {
        return $this->CreatedDateTime;
    }
    /**
     * Set CreatedDateTime value
     * @param string $createdDateTime
     * @return \StructType\ContactLogComment
     */
    public function setCreatedDateTime($createdDateTime = null)
    {
        // validation for constraint: string
        if (!is_null($createdDateTime) && !is_string($createdDateTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($createdDateTime)), __LINE__);
        }
        $this->CreatedDateTime = $createdDateTime;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactLogComment
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
