<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContactLogType StructType
 * @subpackage Structs
 */
class ContactLogType extends MBObject
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var int
     */
    public $ID;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Subtypes
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfContactLogSubtype
     */
    public $Subtypes;
    /**
     * Constructor method for ContactLogType
     * @uses ContactLogType::setID()
     * @uses ContactLogType::setName()
     * @uses ContactLogType::setSubtypes()
     * @param int $iD
     * @param string $name
     * @param \ArrayType\ArrayOfContactLogSubtype $subtypes
     */
    public function __construct($iD = null, $name = null, \ArrayType\ArrayOfContactLogSubtype $subtypes = null)
    {
        $this
            ->setID($iD)
            ->setName($name)
            ->setSubtypes($subtypes);
    }
    /**
     * Get ID value
     * @return int|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \StructType\ContactLogType
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\ContactLogType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Subtypes value
     * @return \ArrayType\ArrayOfContactLogSubtype|null
     */
    public function getSubtypes()
    {
        return $this->Subtypes;
    }
    /**
     * Set Subtypes value
     * @param \ArrayType\ArrayOfContactLogSubtype $subtypes
     * @return \StructType\ContactLogType
     */
    public function setSubtypes(\ArrayType\ArrayOfContactLogSubtype $subtypes = null)
    {
        $this->Subtypes = $subtypes;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ContactLogType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
