<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetClientContactLogsRequest StructType
 * @subpackage Structs
 */
class GetClientContactLogsRequest extends MBRequest
{
    /**
     * The StartDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $StartDate;
    /**
     * The EndDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $EndDate;
    /**
     * The ShowSystemGenerated
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $ShowSystemGenerated;
    /**
     * The ClientID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ClientID;
    /**
     * The StaffIDs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfLong
     */
    public $StaffIDs;
    /**
     * The TypeIDs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt
     */
    public $TypeIDs;
    /**
     * The SubtypeIDs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfInt
     */
    public $SubtypeIDs;
    /**
     * Constructor method for GetClientContactLogsRequest
     * @uses GetClientContactLogsRequest::setStartDate()
     * @uses GetClientContactLogsRequest::setEndDate()
     * @uses GetClientContactLogsRequest::setShowSystemGenerated()
     * @uses GetClientContactLogsRequest::setClientID()
     * @uses GetClientContactLogsRequest::setStaffIDs()
     * @uses GetClientContactLogsRequest::setTypeIDs()
     * @uses GetClientContactLogsRequest::setSubtypeIDs()
     * @param string $startDate
     * @param string $endDate
     * @param bool $showSystemGenerated
     * @param string $clientID
     * @param \ArrayType\ArrayOfLong $staffIDs
     * @param \ArrayType\ArrayOfInt $typeIDs
     * @param \ArrayType\ArrayOfInt $subtypeIDs
     */
    public function __construct($startDate = null, $endDate = null, $showSystemGenerated = null, $clientID = null, \ArrayType\ArrayOfLong $staffIDs = null, \ArrayType\ArrayOfInt $typeIDs = null, \ArrayType\ArrayOfInt $subtypeIDs = null)
    {
        $this
            ->setStartDate($startDate)
            ->setEndDate($endDate)
            ->setShowSystemGenerated($showSystemGenerated)
            ->setClientID($clientID)
            ->setStaffIDs($staffIDs)
            ->setTypeIDs($typeIDs)
            ->setSubtypeIDs($subtypeIDs);
    }
    /**
     * Get StartDate value
     * @return string
     */
    public function getStartDate()
    {
        return $this->StartDate;
    }
    /**
     * Set StartDate value
     * @param string $startDate
     * @return \StructType\GetClientContactLogsRequest
     */
    public function setStartDate($startDate = null)
    {
        // validation for constraint: string
        if (!is_null($startDate) && !is_string($startDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($startDate)), __LINE__);
        }
        $this->StartDate = $startDate;
        return $this;
    }
    /**
     * Get EndDate value
     * @return string
     */
    public function getEndDate()
    {
        return $this->EndDate;
    }
    /**
     * Set EndDate value
     * @param string $endDate
     * @return \StructType\GetClientContactLogsRequest
     */
    public function setEndDate($endDate = null)
    {
        // validation for constraint: string
        if (!is_null($endDate) && !is_string($endDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($endDate)), __LINE__);
        }
        $this->EndDate = $endDate;
        return $this;
    }
    /**
     * Get ShowSystemGenerated value
     * @return bool
     */
    public function getShowSystemGenerated()
    {
        return $this->ShowSystemGenerated;
    }
    /**
     * Set ShowSystemGenerated value
     * @param bool $showSystemGenerated
     * @return \StructType\GetClientContactLogsRequest
     */
    public function setShowSystemGenerated($showSystemGenerated = null)
    {
        // validation for constraint: boolean
        if (!is_null($showSystemGenerated) && !is_bool($showSystemGenerated)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($showSystemGenerated)), __LINE__);
        }
        $this->ShowSystemGenerated = $showSystemGenerated;
        return $this;
    }
    /**
     * Get ClientID value
     * @return string|null
     */
    public function getClientID()
    {
        return $this->ClientID;
    }
    /**
     * Set ClientID value
     * @param string $clientID
     * @return \StructType\GetClientContactLogsRequest
     */
    public function setClientID($clientID = null)
    {
        // validation for constraint: string
        if (!is_null($clientID) && !is_string($clientID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($clientID)), __LINE__);
        }
        $this->ClientID = $clientID;
        return $this;
    }
    /**
     * Get StaffIDs value
     * @return \ArrayType\ArrayOfLong|null
     */
    public function getStaffIDs()
    {
        return $this->StaffIDs;
    }
    /**
     * Set StaffIDs value
     * @param \ArrayType\ArrayOfLong $staffIDs
     * @return \StructType\GetClientContactLogsRequest
     */
    public function setStaffIDs(\ArrayType\ArrayOfLong $staffIDs = null)
    {
        $this->StaffIDs = $staffIDs;
        return $this;
    }
    /**
     * Get TypeIDs value
     * @return \ArrayType\ArrayOfInt|null
     */
    public function getTypeIDs()
    {
        return $this->TypeIDs;
    }
    /**
     * Set TypeIDs value
     * @param \ArrayType\ArrayOfInt $typeIDs
     * @return \StructType\GetClientContactLogsRequest
     */
    public function setTypeIDs(\ArrayType\ArrayOfInt $typeIDs = null)
    {
        $this->TypeIDs = $typeIDs;
        return $this;
    }
    /**
     * Get SubtypeIDs value
     * @return \ArrayType\ArrayOfInt|null
     */
    public function getSubtypeIDs()
    {
        return $this->SubtypeIDs;
    }
    /**
     * Set SubtypeIDs value
     * @param \ArrayType\ArrayOfInt $subtypeIDs
     * @return \StructType\GetClientContactLogsRequest
     */
    public function setSubtypeIDs(\ArrayType\ArrayOfInt $subtypeIDs = null)
    {
        $this->SubtypeIDs = $subtypeIDs;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetClientContactLogsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
