<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetClientsRequest StructType
 * @subpackage Structs
 */
class GetClientsRequest extends MBRequest
{
    /**
     * The IsProspect
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $IsProspect;
    /**
     * The LastModifiedDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $LastModifiedDate;
    /**
     * The ClientIDs
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfString
     */
    public $ClientIDs;
    /**
     * The SearchText
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $SearchText;
    /**
     * Constructor method for GetClientsRequest
     * @uses GetClientsRequest::setIsProspect()
     * @uses GetClientsRequest::setLastModifiedDate()
     * @uses GetClientsRequest::setClientIDs()
     * @uses GetClientsRequest::setSearchText()
     * @param bool $isProspect
     * @param string $lastModifiedDate
     * @param \ArrayType\ArrayOfString $clientIDs
     * @param string $searchText
     */
    public function __construct($isProspect = null, $lastModifiedDate = null, \ArrayType\ArrayOfString $clientIDs = null, $searchText = null)
    {
        $this
            ->setIsProspect($isProspect)
            ->setLastModifiedDate($lastModifiedDate)
            ->setClientIDs($clientIDs)
            ->setSearchText($searchText);
    }
    /**
     * Get IsProspect value
     * @return bool
     */
    public function getIsProspect()
    {
        return $this->IsProspect;
    }
    /**
     * Set IsProspect value
     * @param bool $isProspect
     * @return \StructType\GetClientsRequest
     */
    public function setIsProspect($isProspect = null)
    {
        // validation for constraint: boolean
        if (!is_null($isProspect) && !is_bool($isProspect)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isProspect)), __LINE__);
        }
        $this->IsProspect = $isProspect;
        return $this;
    }
    /**
     * Get LastModifiedDate value
     * @return string
     */
    public function getLastModifiedDate()
    {
        return $this->LastModifiedDate;
    }
    /**
     * Set LastModifiedDate value
     * @param string $lastModifiedDate
     * @return \StructType\GetClientsRequest
     */
    public function setLastModifiedDate($lastModifiedDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifiedDate) && !is_string($lastModifiedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastModifiedDate)), __LINE__);
        }
        $this->LastModifiedDate = $lastModifiedDate;
        return $this;
    }
    /**
     * Get ClientIDs value
     * @return \ArrayType\ArrayOfString|null
     */
    public function getClientIDs()
    {
        return $this->ClientIDs;
    }
    /**
     * Set ClientIDs value
     * @param \ArrayType\ArrayOfString $clientIDs
     * @return \StructType\GetClientsRequest
     */
    public function setClientIDs(\ArrayType\ArrayOfString $clientIDs = null)
    {
        $this->ClientIDs = $clientIDs;
        return $this;
    }
    /**
     * Get SearchText value
     * @return string|null
     */
    public function getSearchText()
    {
        return $this->SearchText;
    }
    /**
     * Set SearchText value
     * @param string $searchText
     * @return \StructType\GetClientsRequest
     */
    public function setSearchText($searchText = null)
    {
        // validation for constraint: string
        if (!is_null($searchText) && !is_string($searchText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($searchText)), __LINE__);
        }
        $this->SearchText = $searchText;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GetClientsRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
