<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateClientServicesRequest StructType
 * @subpackage Structs
 */
class UpdateClientServicesRequest extends MBRequest
{
    /**
     * The Test
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $Test;
    /**
     * The ClientServices
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfClientService
     */
    public $ClientServices;
    /**
     * Constructor method for UpdateClientServicesRequest
     * @uses UpdateClientServicesRequest::setTest()
     * @uses UpdateClientServicesRequest::setClientServices()
     * @param bool $test
     * @param \ArrayType\ArrayOfClientService $clientServices
     */
    public function __construct($test = null, \ArrayType\ArrayOfClientService $clientServices = null)
    {
        $this
            ->setTest($test)
            ->setClientServices($clientServices);
    }
    /**
     * Get Test value
     * @return bool
     */
    public function getTest()
    {
        return $this->Test;
    }
    /**
     * Set Test value
     * @param bool $test
     * @return \StructType\UpdateClientServicesRequest
     */
    public function setTest($test = null)
    {
        // validation for constraint: boolean
        if (!is_null($test) && !is_bool($test)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($test)), __LINE__);
        }
        $this->Test = $test;
        return $this;
    }
    /**
     * Get ClientServices value
     * @return \ArrayType\ArrayOfClientService|null
     */
    public function getClientServices()
    {
        return $this->ClientServices;
    }
    /**
     * Set ClientServices value
     * @param \ArrayType\ArrayOfClientService $clientServices
     * @return \StructType\UpdateClientServicesRequest
     */
    public function setClientServices(\ArrayType\ArrayOfClientService $clientServices = null)
    {
        $this->ClientServices = $clientServices;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdateClientServicesRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
